/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.PCheckUserAccountInfo
 *  fire.pb.login.SCompensationConfig
 *  fire.pb.main.ConfigManager
 *  fire.pb.npc.NpcServiceCond.Condition
 *  xbean.Compensation
 *  xbean.CompensationInfo
 *  xbean.Properties
 *  xtable.Compensation
 *  xtable.Properties
 *  xtable.Usercompensation
 */
package fire.pb.compensation;

import fire.pb.PCheckUserAccountInfo;
import fire.pb.compensation.CompensationCondition;
import fire.pb.compensation.CompensationConditionFactory;
import fire.pb.compensation.CompensationConfig;
import fire.pb.compensation.SpecialCompensationConfig;
import fire.pb.login.SCompensationConfig;
import fire.pb.main.ConfigManager;
import fire.pb.npc.NpcServiceCond.Condition;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;
import xbean.Compensation;
import xbean.CompensationInfo;
import xtable.Properties;
import xtable.Usercompensation;

public class CompensationManager {
    private static Map<Integer, List<CompensationConfig>> configMaps = new HashMap<Integer, List<CompensationConfig>>();
    private static Collection<List<CompensationConfig>> configSets = null;
    private static Map<Long, List<SpecialCompensationConfig>> specialMaps = new HashMap<Long, List<SpecialCompensationConfig>>();
    private static Map<Integer, List<SpecialCompensationConfig>> useridSpecialMaps = new HashMap<Integer, List<SpecialCompensationConfig>>();
    public static Set<Integer> NPC_IDS = new HashSet<Integer>();
    private static final CompensationManager instance;

    private CompensationManager() {
    }

    public static CompensationManager getInstance() {
        return instance;
    }

    public void init() throws Exception {
        configMaps.clear();
        specialMaps.clear();
        useridSpecialMaps.clear();
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH：mm：ss");
        TreeMap compensationConfs = ConfigManager.getInstance().getConf(SCompensationConfig.class);
        for (Map.Entry entry : compensationConfs.entrySet()) {
            SpecialCompensationConfig scc;
            SCompensationConfig conf = (SCompensationConfig)entry.getValue();
            String startTimeStr = conf.startTime;
            Date startDate = sdf.parse(startTimeStr);
            String endTimeStr = conf.endTime;
            Date endDate = sdf.parse(endTimeStr);
            long startTime = startDate.getTime();
            long endTime = endDate.getTime();
            ArrayList<Long> roleids = new ArrayList<Long>();
            ArrayList<Integer> userids = new ArrayList<Integer>();
            this.getLongFromString(roleids, conf.roleid);
            this.getIntergerFromString(userids, conf.userid);
            if (!roleids.isEmpty()) {
                for (Long rid : roleids) {
                    scc = new SpecialCompensationConfig(conf.getCompensationid(), rid, 0, conf.itemid, startTime, endTime, conf.getConditionid(), conf.getMsgid(), conf.getServiceName(), this.getIntergerFromString(new ArrayList<Integer>(), conf.serverid));
                    this.addSpecialCompensationConfig(rid, scc, specialMaps);
                }
                continue;
            }
            if (!userids.isEmpty()) {
                for (Integer uid : userids) {
                    scc = new SpecialCompensationConfig(conf.getCompensationid(), 0L, uid, conf.itemid, startTime, endTime, conf.getConditionid(), conf.getMsgid(), conf.getServiceName(), this.getIntergerFromString(new ArrayList<Integer>(), conf.serverid));
                    this.addSpecialCompensationConfig(uid, scc, useridSpecialMaps);
                }
                continue;
            }
            CompensationConfig compenConfig = new CompensationConfig(startTime, endTime, conf.getItemid(), conf.getCompensationid(), conf.getMsgid(), conf.getServiceName(), conf.getConditionid(), this.getIntergerFromString(new ArrayList<Integer>(), conf.serverid), conf.onChannel, conf.offChannel);
            this.addCompensationConfig(compenConfig);
        }
        this.setConfigSet();
    }

    private void getLongFromString(List<Long> result, String roleids) {
        if (roleids.length() > 3) {
            String[] strs;
            for (String str : strs = roleids.split(";")) {
                result.add(Long.parseLong(str));
            }
        }
    }

    private List<Integer> getIntergerFromString(List<Integer> result, String roleids) {
        if (roleids != null && roleids.length() > 3) {
            String[] strs;
            for (String str : strs = roleids.split(";")) {
                result.add(Integer.valueOf(str));
            }
        }
        return result;
    }

    private <T> void addSpecialCompensationConfig(T id, SpecialCompensationConfig scc, Map<T, List<SpecialCompensationConfig>> map) {
        List<SpecialCompensationConfig> configs = map.get(id);
        if (configs == null) {
            configs = new ArrayList<SpecialCompensationConfig>();
            configs.add(scc);
            map.put(id, configs);
        } else {
            configs.add(scc);
        }
    }

    public void addDynamicServices(long roleid, int npcid, ArrayList<Integer> result) {
        if (NPC_IDS.contains(npcid)) {
            int n;
            List<SpecialCompensationConfig> confs;
            long curTime = System.currentTimeMillis();
            Compensation compensation = xtable.Compensation.select((Long)roleid);
            for (List<CompensationConfig> list : configSets) {
                for (CompensationConfig config : list) {
                    if (!config.isInCompensationTime(curTime) || !this.checkCondition(config.getCondtions(), roleid) || !this.checkZoneids(config.getZoneids(), ConfigManager.getGsZoneId()) || compensation != null && CompensationManager.alreadyReceiveAward(compensation, config) || !this.checkPlats(config, roleid)) continue;
                    result.add(config.getCompensationid());
                }
            }
            List<SpecialCompensationConfig> configs = specialMaps.get(roleid);
            if (configs != null) {
                for (SpecialCompensationConfig scc : configs) {
                    if (!scc.isInTime(curTime) || !this.checkCondition(scc.getCondtions(), roleid) || !this.checkZoneids(scc.getZoneids(), ConfigManager.getGsZoneId()) || compensation != null && CompensationManager.alreadyReceiveAward(compensation, scc)) continue;
                    result.add(scc.getId());
                }
            }
            if ((confs = useridSpecialMaps.get(n = Properties.selectUserid((Long)roleid).intValue())) != null) {
                for (SpecialCompensationConfig scc : confs) {
                    if (!scc.isInTime(curTime) || !this.checkCondition(scc.getCondtions(), roleid) || !this.checkZoneids(scc.getZoneids(), ConfigManager.getGsZoneId())) continue;
                    Compensation usercompensation = Usercompensation.select((String)String.valueOf(n));
                    if (usercompensation == null) {
                        result.add(scc.getId());
                        continue;
                    }
                    CompensationInfo compensationInfo = (CompensationInfo)usercompensation.getCompensationmap().get(scc.getId());
                    if (compensationInfo != null && scc.isInTime(compensationInfo.getReceiveawardtime())) continue;
                    result.add(scc.getId());
                }
            }
            PCheckUserAccountInfo.addDynamicService((long)roleid, result);
        }
    }

    public static boolean alreadyReceiveAward(Compensation compensation, SpecialCompensationConfig scc) {
        CompensationInfo compensationInfo = (CompensationInfo)compensation.getCompensationmap().get(scc.getId());
        return compensationInfo != null && scc.isInTime(compensationInfo.getReceiveawardtime());
    }

    public static boolean alreadyReceiveAward(Compensation compensation, CompensationConfig config) {
        CompensationInfo compensationInfo = (CompensationInfo)compensation.getCompensationmap().get(config.getCompensationid());
        return compensationInfo != null && config.isInCompensationTime(compensationInfo.getReceiveawardtime());
    }

    public void addCompensationConfig(CompensationConfig config) {
        int compensationid = config.getCompensationid();
        List<CompensationConfig> configs = configMaps.get(compensationid);
        if (configs == null) {
            configs = new ArrayList<CompensationConfig>();
            configs.add(config);
            configMaps.put(compensationid, configs);
        } else {
            configs.add(config);
        }
    }

    public void setConfigSet() {
        configSets = configMaps.values();
    }

    public List<CompensationConfig> getCompensationConfigsInTime(long roleid, long time) {
        ArrayList<CompensationConfig> result = new ArrayList<CompensationConfig>();
        for (List<CompensationConfig> configList : configSets) {
            for (CompensationConfig config : configList) {
                if (!config.isInCompensationTime(time) || !this.checkCondition(config.getCondtions(), roleid) || !this.checkZoneids(config.getZoneids(), ConfigManager.getGsZoneId()) || !this.checkPlats(config, roleid)) continue;
                result.add(config);
            }
        }
        return result;
    }

    public List<SpecialCompensationConfig> getCompensationConfigsInTimeAndAvailable(long time, long roleid) {
        ArrayList<SpecialCompensationConfig> result = new ArrayList<SpecialCompensationConfig>();
        List<SpecialCompensationConfig> configList = specialMaps.get(roleid);
        if (configList != null && !configList.isEmpty()) {
            for (SpecialCompensationConfig config : configList) {
                if (!config.isInTime(time) || !this.checkCondition(config.getCondtions(), roleid) || !this.checkZoneids(config.getZoneids(), ConfigManager.getGsZoneId())) continue;
                result.add(config);
            }
        }
        return result;
    }

    public List<SpecialCompensationConfig> getUseridCompensationConfigsInTimeAndAvailable(long roleid, long time, String platformUid) {
        ArrayList<SpecialCompensationConfig> result = new ArrayList<SpecialCompensationConfig>();
        List<SpecialCompensationConfig> configList = useridSpecialMaps.get(Integer.valueOf(platformUid));
        if (configList != null && !configList.isEmpty()) {
            for (SpecialCompensationConfig config : configList) {
                if (!config.isInTime(time) || !this.checkCondition(config.getCondtions(), roleid) || !this.checkZoneids(config.getZoneids(), ConfigManager.getGsZoneId())) continue;
                result.add(config);
            }
        }
        return result;
    }

    public List<CompensationConfig> getConfigFromServiceid(long roleid, int serviceid) {
        ArrayList<CompensationConfig> result = new ArrayList<CompensationConfig>();
        List<CompensationConfig> configs = configMaps.get(serviceid);
        if (configs != null) {
            for (CompensationConfig compensationConfig : configs) {
                if (!this.checkCondition(compensationConfig.getCondtions(), roleid) || !this.checkZoneids(compensationConfig.getZoneids(), ConfigManager.getGsZoneId()) || !this.checkPlats(compensationConfig, roleid)) continue;
                result.add(compensationConfig);
            }
        }
        return result;
    }

    public boolean checkPlats(CompensationConfig compensationConfig, long roleid) {
        if (compensationConfig.getPlats().equals("0") && compensationConfig.getNonPlats().equals("0")) {
            return true;
        }
        xbean.Properties properties = Properties.select((Long)roleid);
        String platUid = properties.getPlatformuid();
        String platName = platUid.substring(platUid.indexOf("$") + 1);
        if (platName.length() != 4) {
            return false;
        }
        if (compensationConfig.getPlats().length() > 1) {
            return compensationConfig.getPlats().contains(platName);
        }
        if (compensationConfig.getNonPlats().length() > 1) {
            return !compensationConfig.getNonPlats().contains(platName);
        }
        return false;
    }

    public boolean checkZoneids(List<Integer> zoneids, int gsZoneId) {
        if (zoneids == null || zoneids.isEmpty()) {
            return true;
        }
        return zoneids.contains(gsZoneId);
    }

    public List<SpecialCompensationConfig> getSpecialConfigFromServiceid(int serviceid, long roleid) {
        ArrayList<SpecialCompensationConfig> result = new ArrayList<SpecialCompensationConfig>();
        List<SpecialCompensationConfig> configs = specialMaps.get(roleid);
        if (configs != null) {
            for (SpecialCompensationConfig scc : configs) {
                if (scc.getId() != serviceid || !this.checkCondition(scc.getCondtions(), roleid) || !this.checkZoneids(scc.getZoneids(), ConfigManager.getGsZoneId())) continue;
                result.add(scc);
            }
        }
        return result;
    }

    public List<SpecialCompensationConfig> getUseridSpecialConfigFromServiceid(long roleid, int serviceid, String platformUid) {
        ArrayList<SpecialCompensationConfig> result = new ArrayList<SpecialCompensationConfig>();
        List<SpecialCompensationConfig> configs = useridSpecialMaps.get(Integer.parseInt(platformUid));
        if (configs != null) {
            for (SpecialCompensationConfig scc : configs) {
                if (scc.getId() != serviceid || !this.checkCondition(scc.getCondtions(), roleid) || !this.checkZoneids(scc.getZoneids(), ConfigManager.getGsZoneId())) continue;
                result.add(scc);
            }
        }
        return result;
    }

    public static Map<Long, List<SpecialCompensationConfig>> getSpecialCompensationConfMap() {
        return specialMaps;
    }

    public static Map<Integer, List<SpecialCompensationConfig>> getUseridSpecialMaps() {
        return useridSpecialMaps;
    }

    public boolean checkCondition(List<CompensationCondition> conditions, long roleid) {
        if (conditions == null || conditions.isEmpty()) {
            return true;
        }
        for (CompensationCondition cond : conditions) {
            Condition icc = CompensationConditionFactory.getCondition(cond.getConditionid());
            if (icc == null) {
                return false;
            }
            if (icc.CheckCond(roleid, cond.getArgs()[0], cond.getArgs()[1])) continue;
            return false;
        }
        return true;
    }

    static {
        NPC_IDS.add(10963);
        NPC_IDS.add(10964);
        NPC_IDS.add(10965);
        NPC_IDS.add(10966);
        instance = new CompensationManager();
    }
}

